; ***************************************
; *                                     *
; *    AMIGA GAME STUDIO startup 0.1a   *
; *                                     *
; *-------------------------------------*
; *                                     *
; * Initialize : Display.library        *
; *------------- Screens.library        *
; *              Joystick.library       *
; *              MemoryCopy.library     *
; *              MemoryBanks.library    *
; *              Chunky.library         *
; *              Ilbm.library           *
; *                                     *
; *-------------------------------------*
; *                                     *
; ***************************************
; This is the beta test startup opening all libraries
; And let you use them easily.
;
	Include	"Includes:Exec/Exec.s"		;
;
	IncDir	"AmigaGS Dev:Includes/"		;
	Include	"DisplayAGA.i"				; + Macros
	Include	"Joystick.i"				;
	Include	"MemoryBanks.i"				; + Macros
	Include	"MemoryCopy.i"				;
	Include	"ScreensAGA.i"				; + Macros
	Include	"FxIlbm.i"
	include	"Chunky.i"
;
	Include	"_libraries.macro"
;		InitLib		LIB_GLOBAL_NAME				Uses A6
;		LibCall		LIB_GLOBAL_NAME,FUNCTION	Uses A5
	Include	"_ScreensAGA.macro"
;		ScreenOpen	SCREEN,XSIZE,YSIZE,DEPTH
;		ScreenClose	SCREEN
	Include	"_MemoryBanks.macro"
;		ReserveChip		BANK,SIZE
;		ReserveFast		BANK,SIZE
;		ReservePublic	BANK,SIZE
;		Reserve24BitDMA	BANK,SIZE
;		EraseBank		BANK
;		EraseAll
	Include	"_DisplayAGA.macro"
;		InitDisplay
;		CloseDisplay
;		WaitVbl
;		RefreshCopper
;		SetColor		REG,ROUGE,VERT,BLEU (24bits values)
; Initialisation des librairies de AGS.
	InitLib	Display
	InitLib	Screens
	InitLib	Banks
	InitLib	Copy
	InitLib	Joyport
	InitLib	FxIlbm
	InitLib	Chunky
; Initialisation des autres librairies.
;
; ENSEMBLE DES LIBRAIRIES DE Amiga Game Studio.
;
	Bra.w	START
Display:
	Dc.l	0
	Dc.b	"AmigaGS:Libs/displayaga.library",0
	EVEN
Screens:
	Dc.l	0
	Dc.b	"AmigaGS:Libs/screensaga.library",0
	EVEN
Banks:
	Dc.l	0
	Dc.b	"AmigaGS:Libs/memorybanks.library",0
	EVEN
Copy:
	Dc.l	0
	Dc.b	"AmigaGS:Libs/memory680x0.library",0
	EVEN
Joyport:
	Dc.l	0
	Dc.b	"AmigaGS:Libs/joystick.library",0
	EVEN
FxIlbm:
	Dc.l	0
	Dc.b	"AmigaGS:Libs/fxilbm.library",0
	EVEN
Chunky:
	Dc.l	0
	Dc.b	"AmigaGS:Libs/chunkycpu.library",0
	EVEN

START:
